<?php
/**
 * @package     Falang for Joomla!
 * @author      Stéphane Bouey <stephane.bouey@faboba.com> - http://www.faboba.com
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @copyright   Copyright (C) 2012-2021 Faboba. All rights reserved.
 */

// No direct access to this file
defined('_JEXEC') or die();

class plgSearchFalangK2InstallerScript
{
    protected $minimumPHPVersion = '7.0.0';
    protected $minimumJoomlaVersion = '3.9.0';
    protected $maximumJoomlaVersion = '4.4.99';

    public function install($parent)
    {
        // Enable the extension
        $this->enablePlugin();

        return true;
    }

    public function uninstall($parent)
    {
    }

    public function update($parent)
    {
    }

    public function preflight($type, $parent)
    {
        // Check the minimum PHP version
        if (!version_compare(PHP_VERSION, $this->minimumPHPVersion, '>='))
        {
            $msg = '<p>You need PHP ' . $this->minimumPHPVersion . ' or later to install this plugin.</p>';
            JLog::add($msg, JLog::WARNING, 'jerror');

            return false;
        }

        // Check the minimum Joomla! version
        if (!version_compare(JVERSION, $this->minimumJoomlaVersion, '>='))
        {
            $msg = '<p>You need Joomla! ' . $this->minimumJoomlaVersion . ' or later to install this plugin.</p>';
            JLog::add($msg, JLog::WARNING, 'jerror');

            return false;
        }

        // Check the minimum Joomla! version
        if( version_compare(JVERSION, $this->maximumJoomlaVersion, 'gt') ) {
            $msg = '<p>You need a Joomla version between ' . $this->minimumJoomlaVersion . ' and ' . $this->maximumJoomlaVersion . ' to install this plugin.</p>';
            JLog::add($msg, JLog::WARNING, 'jerror');

            return false;
        }

        return true;
    }

    public function postflight($type, $parent)
    {
    }

    private function enablePlugin()
    {
        try
        {
            $db    = JFactory::getDbo();
            $query = $db->getQuery(true)
                        ->update('#__extensions')
                        ->set($db->qn('enabled') . ' = ' . $db->q(1))
                        ->where('type = ' . $db->quote('plugin'))
                        ->where('folder = ' . $db->quote('search'))
                        ->where('element = ' . $db->quote('falangk2'));
            $db->setQuery($query);
            $db->execute();
        }
        catch (\Exception $e)
        {
            return;
        }
    }
}
